package com.zsc.edu.dify.modules.message.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.zsc.edu.dify.modules.system.entity.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

/**
 * 消息
 *
 * @author harry_yao
 */
@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
@TableName("sys_notice")
public class Notice extends BaseEntity {

    /**
     * 消息类型
     */
    public NoticeType type = NoticeType.MESSAGE;

    /**
     * 是否系统生成
     */
    public Boolean system = false;

    /**
     * 是否需要发送邮件
     */
    public Boolean email;


    /**
     * 是否需要发送短信
     */
    public Boolean sms;

    /**
     * 消息内容是否富文本，True则以富文本形式发送
     */
    public Boolean html;

    /**
     * 标题
     */
    public String title;

    /**
     * 消息内容
     */
    public String content;

    /**
     * 部门ID(权限)
     */
    public Long deptId;
}
