package com.zsc.edu.dify.modules.message.query;

import com.zsc.edu.dify.modules.message.entity.NoticeType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * 用户消息Query
 *
 * @author harry_yao
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class UserNoticeQuery {

    /**
     * 用户ID
     */
    public Long userId;

    /**
     * 标题，模糊查询
     */
    public String title;

    /**
     * 消息类型
     */
    public NoticeType type;

    /**
     * 用户名或真实姓名，用户名准确查询，姓名模糊查询
     */
    public String name;

    /**
     * 是否系统自动生成
     */
    public Boolean system;

    /**
     * 是否已读
     */
    public Boolean isRead;

    /**
     * 消息创建时间区间起始
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    public LocalDateTime createAtBegin;

    /**
     * 消息创建时间区间终止
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    public LocalDateTime createAtEnd;

}
