package com.zsc.edu.dify.modules.system.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.*;

import java.util.List;
import java.util.Set;

/**
 * 用户
 *
 * @author harry yao
 */
@AllArgsConstructor
@NoArgsConstructor
@Setter
@Getter
@JsonIgnoreProperties({"password"})
@EqualsAndHashCode(callSuper = false)
@TableName(value = "sys_user")
public class User extends BaseEntity {

    /**
     * 用户名
     */
    public String username;

    /**
     * 密码
     */
    public String password;

    /**
     * 手机号码
     */
    public String phone;

    /**
     * 电子邮件
     */
    public String email;

    /**
     * 启用状态
     */
    public Boolean enableState = true;
    /**
     *
     *昵称
     * */
    public String name;

    /**
     * 所属部门ID
     */
    public Long deptId;

    /**
     * 所属部门
     */
    @TableField(exist = false)
    public Dept dept;
    /**
     * 所属部门及子部门ID
     */
    @TableField(exist = false)
    public Set<Long> dataScopeDeptIds;

    /**
     * 角色ID
     */
    public Long roleId;

    /**
     * 拥有的当前角色
     */
    @TableField(exist = false)
    public Role role;

    /**
     * 拥有的所有角色
     */
    @TableField(exist = false)
    public List<Role> roles;
    /**
     * 头像
     */
    public String avatar;
    /**
     * 地址
     */
    public String address;


}

